(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprint_xmlc.bin generated code *)

let print_xml_index px_a ppf = function
  | a_u_t -> Uindex_print_xml.print_xml_t px_a ppf a_u_t
;;

let print_xml_indices _px_a ppf = function
  | a -> Lib_print_xml.print_xml_abstract ppf a
;;

let print_xml_elements px_a ppf = function
  | a_a -> Lib_print_xml.print_xml_Array px_a ppf a_a
;;

let print_xml_t px_a ppf = function
  | {
      Uuniverse.indices = a_i;
      Uuniverse.elements = a_e;
      Uuniverse.cardinal = u_t;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; print_xml_indices px_a ppf a_i;
    Format.fprintf ppf "%,;"; print_xml_elements px_a ppf a_e;
    Format.fprintf ppf "%,;"; Unatural_print_xml.print_xml_t ppf u_t;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

(* End of ocamlprint_xmlc.bin generated code *)
