(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: upositive_rational_types.ml,v 1.3 2014/01/10 15:28:04 fclement Exp $ *)

(* The private type of positive rational numbers. *)

let prt_failwith = Upervasives.failwith "Upositive_rational";;

type t =
  {
   numerator : Unatural.t;
   denominator : Unatural.t;
  }
;;

let to_t p q =
  if q = Unatural._0_ then prt_failwith "of_nat" "zero denominator" else
  if p = Unatural._0_ then prt_failwith "of_nat" "zero numerator" else
  let g = Unatural.gcd p q in
  { numerator = Unatural.div p g; denominator = Unatural.div q g; }
;;
